<template>
	<v-card>
		<task-list-toolbar @input="loadTasks" />
		<v-list>
			<task-list-item v-for="(task) in tasks" :key="task.id" :task="task" />
		</v-list>
		<!-- Mobile button + dialog -->
		<task-add v-model="tasks" @input="loadTasks" />
	</v-card>
</template>

<script>
import TaskListToolbar from "@/components/TaskListToolbar";
import TaskListItem from "@/components/TaskListItem";
import TaskAdd from "@/components/TaskAdd";
import taskService from "@/mixins/TaskService";

export default {
	components: {
		TaskListToolbar,
		TaskListItem,
		TaskAdd
	},

	mixins: [taskService],

	data() {
		return {
			tasks: []
		};
	},

	// Updates list after switching routes
	watch: {
		$route: "loadTasks"
	},

	created() {
		this.loadTasks();
	},

	methods: {
		loadTasks() {
			this.taskService.findAll().then(t => (this.tasks = t));
		}
	}
};
</script>
